#ifndef _angsd_
#define _angsd_
 
#define FOR(i,n) for(i=0; i<n; i++)
#include "shared.h"
#include <vector>

namespace angsd{
  //assuming samtools ordering
  static int majorminor[4][4] = 
    {
      {0,1,2,3},
      {1,4,5,6},
      {2,5,7,8},
      {3,6,8,9}
    };
  

  template<typename T>
  struct Matrix {
    int x;
    int y;
    T **matrix;
  };

  int getArg(const char* argName,int type,argStruct *arguments);
  float getArg(const char* argName,float type,argStruct *arguments);
  char* getArg(const char* argName,char* type,argStruct *arguments);
  char* getArg(const char* argName,const char* type,argStruct *arguments);
  double getArg(const char* argName,double type,argStruct *arguments);
  double getMax(double a,double b, double c);
  double addProtect2(double a,double b);
  double addProtect3(double a,double b, double c);
  Matrix<double> getMatrix(const char *name,int doBinary,int lens);
  int fexists(const char* str);
  double **get3likes(funkyPars *pars);
  double **get3likes(funkyPars *pars,int *keepInd);
  double **getlikes(funkyPars *pars,int *keepInd);
  void swapDouble (double& first, double& second);
  int matinv( double x[], int n, int m, double space[]);
  void deleteMatrix(Matrix<double> mat);
  void printMatrix(Matrix<double> mat,FILE *file);
  void logrescale(double *ary,int len);
  std::vector<char*> getFilenames(char * name);
}
#endif
